// Edit.java

// relocate reply
//	Reply reloc = request.makeReply(HTTP.MOVED_TEMPORARILY);
//	reloc.setLocation(editor.getURL()) ;


package sl.TrackTrek ;

import w3c.jigsaw.html.* ;
import w3c.jigsaw.forms.*;
import w3c.www.http.*;
import w3c.jigsaw.http.*;
import w3c.jigsaw.resources.*;

import sl.TrackTrek.Page;
import sl.TrackTrek.DataType;
import sl.TrackTrek.DateType;
import sl.TrackTrek.StringType;
import sl.TrackTrek.TimeType;
import sl.TrackTrek.Distance;



public class Edit extends PostableResource {

	// The message attribute index
	protected static int ATTR_MESSAGE = -1 ;
	// The headers attribute index
	protected static int ATTR_HEADERS = -1 ;

	static {
		Attribute a   = null ;
		Class     cls = null ;
		
		try {
                        cls = Class.forName("sl.TrackTrek.Edit");
		} catch (Exception ex) {
			ex.printStackTrace() ;
			System.exit(1) ;
		}
		// Register the message attribute:
		a = new StringAttribute("message", "Hello", Attribute.EDITABLE);
		ATTR_MESSAGE = AttributeRegistry.registerAttribute(cls, a) ;
		// Register the headers attribute:
		a = new StringArrayAttribute("headers", null, Attribute.EDITABLE) ;
		ATTR_HEADERS = AttributeRegistry.registerAttribute(cls, a) ;
	}

	public Reply get(Request request)
		throws HTTPException
	{
                if (request.getQueryString() == null || request.getQueryString().startsWith("SortOrder="))
		{
		  // Create the HTML generator, and set titles:
		  HtmlGenerator g = new HtmlGenerator("TrackTrek 1.02");
                  StringType strs[] = new StringType[3];
		  Distance dist[] = new Distance[3];
                  strs[0] = new StringType();
                  strs[1] = new StringType();
                  strs[2] = new StringType();
                  dist[0] = new Distance();
                  dist[1] = new Distance();
                  dist[2] = new Distance();
                  DataType content[][] = new DataType[3][2];
                  content[0][0] = strs[0];
                  content[0][1] = dist[0];
                  content[1][0] = strs[1];
                  content[1][1] = dist[1];
                  content[2][0] = strs[2];
                  content[2][1] = dist[2];
		  String label[] = new String[3];
                  String queryString = request.getQueryString();
                  if (queryString == null)
                    queryString = new String("1");
		  int x1, x2;
		  int sortOrder = (Integer.valueOf(queryString.substring(queryString.length() - 1))).intValue();
                  sl.TrackTrek.Page.header(g, "Select a Track Meet", "");

		  label[0] = "Track Meet";
		  label[1] = "District:";
                  content[0][0].setValue("UIL Regionals");
                  content[0][1].setValue(30000);
                  content[1][0].setValue("Cats meow");
                  content[1][1].setValue(30340);
                  content[2][0].setValue("Persians purr");
                  content[2][1].setValue(400);
                  sl.TrackTrek.Page.table(g, content, label, 3, 2, "edit", sortOrder, null, null);

                  Reply reply = createDefaultReply(request, HTTP.OK) ;
                  reply.setStream(g) ;
                  return reply ;
		}
		else
		{
		  String cmdLine = request.getQueryString();

		  HtmlGenerator g = new HtmlGenerator("TrackTrek 1.02");
		  g.append("<h1>Welcome to TrackTrek!</h1>");
		  g.append("\n\nQuery String: ");
		  g.append(((cmdLine == "")? "<em>none</em>" : cmdLine) + "\n\n");
                  Reply reply = createDefaultReply(request, HTTP.OK) ;
                  reply.setStream(g) ;
                  return reply ;
		}
	}

}

