package sl.TrackTrek ;

import w3c.jigsaw.http.*;
import w3c.jigsaw.resources.*;

import w3c.jigsaw.html.* ;
import w3c.jigsaw.forms.*;

public class main extends PostableResource {

	// The message attribute index
	protected static int ATTR_MESSAGE = -1 ;
	// The headers attribute index
	protected static int ATTR_HEADERS = -1 ;

	static {
		Attribute a   = null ;
		Class     cls = null ;
		
		try {
			cls = Class.forName("sl.TrackTrek.main");
		} catch (Exception ex) {
			ex.printStackTrace() ;
			System.exit(1) ;
		}
		// Register the message attribute:
		a = new StringAttribute("track database", "/jigsaw/classes/sl/TrackTrek/main.track-database", Attribute.EDITABLE);
		ATTR_MESSAGE = AttributeRegistery.registerAttribute(cls, a) ;
		// Register the headers attribute:
		a = new StringArrayAttribute("login message", null, Attribute.EDITABLE) ;
		ATTR_HEADERS = AttributeRegistery.registerAttribute(cls, a) ;
	}

	/**
	 * Display the resource message with the request headers.
	 * @param request The request to handle.
	 * @exception HTTPException If processing the request failed.
	 */

	public Reply get(Request request)
		throws HTTPException
	{
		// Create the HTML generator, and set titles:
		HtmlGenerator g = new HtmlGenerator("TrackTrek 1.02");
		g.append("<h1>Welcome to TrackTrek!</h1>");

		g.append("<h1>Untitled Form Page</h1>\n");
		g.append("<hr>\n");
		g.append("<p>This is an explanation of the purpose of the form ...</p>\n");
		g.append("<form action=\"/TrackTrekEdit/\" method=\"GET\">\n");
		g.append("<p>Please provide the following contact information:</p>\n");
		g.append("<blockquote>\n");
		g.append("<pre><em>            Name </em><input type=text size=35 maxlength=256 name=\"Contact_FullName\">\n");
		g.append("<em>           Title </em><input type=text size=35 maxlength=256 name=\"Contact_Title\">\n");
		g.append("<em>    Organization </em><input type=text size=35 maxlength=256 name=\"Contact_Organization\">\n");
		g.append("<em>      Work Phone </em><input type=text size=25 maxlength=25 name=\"Contact_WorkPhone\">\n");
		g.append("<em>             FAX </em><input type=text size=25 maxlength=25 name=\"Contact_FAX\">\n");
		g.append("<em>          E-mail </em><input type=text size=25 maxlength=256 name=\"Contact_Email\">\n");
		g.append("<em>             URL </em><input type=text size=25 maxlength=25 name=\"Contact_URL\">\n");
		g.append("</pre>\n");
		g.append("</blockquote>\n");
		g.append("<p>Enter your cat's name in the space provided below.</p>\n");
		g.append("<blockquote>\n");
		g.append("<p><input type=text size=35 maxlength=256 name=\"cats\"> <br>\n");
		g.append("</p>\n");
		g.append("</blockquote>\n");
		g.append("<p><input type=submit value=\"Submit Form\"> <input type=reset value=\"Reset Form\"> </p>\n");
		g.append("</form>\n");
		g.append("<hr>\n");
		g.append("<h5>Copyright information goes here.<br>\n");
		g.append("Last revised: <!--VERMEER\n");
		g.append("   BOT=TimeStamp\n");
		g.append("   S-Type=\"EDITED\"\n");
		g.append("   S-Format=\"%B %d, %Y\"\n");
		g.append(" --></h5>\n");

		// Emit the message:
		g.append("<p>"+getValue(ATTR_MESSAGE, null));
		// Now emit the requested headers:
		String headers[] = (String[]) getValue(ATTR_HEADERS, null) ;
		if ( headers != null ) {
			g.append("<hr><h2>Request headers:</h2><dl>");
			for (int i = 0 ; i < headers.length ; i++) {
				g.append("<dt>"+headers[i]+"</dt><dd>");
				String value = request.getField(headers[i]);
				g.append((value == null)
					 ? "<em>undefined</em>"
					 : request.getField(headers[i])) ;
			}
		}
		Reply reply = request.makeReply(HTTP.OK) ;
		reply.setStream(g) ;
		return reply ;
	}
	public Reply post(Request request)
		throws HTTPException
	{
		// Create the HTML generator, and set titles:
		HtmlGenerator g = new HtmlGenerator("TrackTrek 1.02 (posted!)");
		g.append("<h1>Welcome to TrackTrek! posted!</h1>");
		// Emit the message:
				g.append("hello!");
		g.append("<p>"+getValue(ATTR_MESSAGE, null));
		// Now emit the requested headers:
				g.append("hello!");
/*		String headers[] = (String[]) getValue(ATTR_HEADERS, null) ;
		if ( headers != null ) {
			g.append("<hr><h2>Request headers:</h2><dl>");
			for (int i = 0 ; i < headers.length ; i++) {
				g.append("<dt>"+headers[i]+"</dt><dd>");
				String value = request.getField(headers[i]);
				g.append((value == null)
					 ? "<em>undefined</em>"
					 : request.getField(headers[i])) ;
			}
		}*/
				g.append("hello!");
/*				String value = request.getField("cats");
				g.append((value == null)
					 ? "<em>undefined</em>"
					 : request.getField("cats")) ;*/
				g.append("\n\nQuery String: ");
				g.append(request.getQueryString("[none]")+"\n\n");
				g.append("The name of your really cute furry fluffy feline: ");
				try
				{
				  g.append(request.getFieldString("cats") + "\n\n");
				} catch (w3c.mime.MIMEException msg) { g.append("sorry..."); }
		Reply reply = request.makeReply(HTTP.OK) ;
		reply.setStream(g) ;
		return reply ;
	}

}

